package ru.dbotthepony.mc.otm.client.model.entity;

import net.minecraft.client.model.HierarchicalModel;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.builders.*;
import net.minecraft.world.entity.Entity;
import ru.dbotthepony.mc.otm.entity.RocketProjectile;
import ru.dbotthepony.mc.otm.registry.MNames;

import static ru.dbotthepony.mc.otm.OverdriveThatMatters.loc;

public class RocketModel extends HierarchicalModel<RocketProjectile> {
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(loc(MNames.ROCKET), "main");
	private final ModelPart mainPart;

	public RocketModel(ModelPart root) {
		this.mainPart = root.getChild("bb_main");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshDefinition = new MeshDefinition();
		PartDefinition partDefinition = meshDefinition.getRoot();

		partDefinition.addOrReplaceChild(
			"bb_main",
			CubeListBuilder.create()
				.texOffs(0, 0)
				.addBox(-2.0F, -2.0F, -6.0F, 4.0F, 4.0F, 12.0F),
			PartPose.offset(0.0F, 0.0F, 0.0F)
		);

		return LayerDefinition.create(meshDefinition, 32, 16);
	}

	@Override
	public void setupAnim(RocketProjectile entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {

	}

	@Override
	public ModelPart root() {
		return mainPart;
	}
}
