package ru.dbotthepony.mc.otm.client.render.entity

import com.mojang.blaze3d.vertex.PoseStack
import net.minecraft.client.model.HierarchicalModel
import net.minecraft.client.renderer.MultiBufferSource
import net.minecraft.client.renderer.RenderType
import net.minecraft.client.renderer.entity.EntityRendererProvider
import net.minecraft.client.renderer.entity.MobRenderer
import net.minecraft.client.renderer.entity.layers.RenderLayer
import net.minecraft.client.renderer.texture.OverlayTexture
import net.minecraft.resources.ResourceLocation
import ru.dbotthepony.mc.otm.OverdriveThatMatters.loc
import ru.dbotthepony.mc.otm.client.model.entity.DroneModel
import ru.dbotthepony.mc.otm.entity.Drone

class DroneRenderer(context: EntityRendererProvider.Context)
	: MobRenderer<Drone, HierarchicalModel<Drone>>(context, DroneModel.getModel(), 0.8f) {
	override fun getTextureLocation(entity: Drone): ResourceLocation = TEXTURE_LOCATION

	init {
		this.addLayer(DroneEmissiveLayer(this, model))
	}

	companion object {
		private val TEXTURE_LOCATION = loc("textures/entity/drone.png")
	}
}

class DroneEmissiveLayer(
	entityRenderer: DroneRenderer,
	model: HierarchicalModel<Drone>
) : RenderLayer<Drone, HierarchicalModel<Drone>>(entityRenderer) {

	private val emissive = loc("textures/entity/drone_emissive.png")


	override fun render(
		poseStack: PoseStack,
		bufferSource: MultiBufferSource,
		packedLight: Int,
		entity: Drone,
		limbSwing: Float,
		limbSwingAmount: Float,
		partialTicks: Float,
		ageInTicks: Float,
		netHeadYaw: Float,
		headPitch: Float
	) {
		val buffer = bufferSource.getBuffer(RenderType.eyes(emissive))

		this.parentModel.renderToBuffer(
			poseStack,
			buffer,
			15728640,
			OverlayTexture.NO_OVERLAY
		)
	}
}
