package ru.dbotthepony.mc.otm.client.render.entity

import com.mojang.blaze3d.vertex.PoseStack
import net.minecraft.client.model.HierarchicalModel
import net.minecraft.client.renderer.MultiBufferSource
import net.minecraft.client.renderer.RenderType
import net.minecraft.client.renderer.entity.EntityRendererProvider
import net.minecraft.client.renderer.entity.MobRenderer
import net.minecraft.client.renderer.entity.layers.RenderLayer
import net.minecraft.client.renderer.texture.OverlayTexture
import net.minecraft.resources.ResourceLocation
import ru.dbotthepony.mc.otm.OverdriveThatMatters.loc
import ru.dbotthepony.mc.otm.client.model.entity.LoaderModel
import ru.dbotthepony.mc.otm.entity.Loader

class LoaderRenderer(context: EntityRendererProvider.Context)
	: MobRenderer<Loader, HierarchicalModel<Loader>>(context, LoaderModel.getModel(), 0.8f) {
	override fun getTextureLocation(entity: Loader): ResourceLocation = TEXTURE_LOCATION

	init {
		this.addLayer(LoaderEmissiveLayer(this, model))
	}

	companion object {
		private val TEXTURE_LOCATION = loc("textures/entity/loader.png")
	}
}

class LoaderEmissiveLayer(
	entityRenderer: LoaderRenderer,
	model: HierarchicalModel<Loader>
) : RenderLayer<Loader, HierarchicalModel<Loader>>(entityRenderer) {

	private val emissive = loc("textures/entity/loader_emissive.png")


	override fun render(
		poseStack: PoseStack,
		bufferSource: MultiBufferSource,
		packedLight: Int,
		entity: Loader,
		limbSwing: Float,
		limbSwingAmount: Float,
		partialTicks: Float,
		ageInTicks: Float,
		netHeadYaw: Float,
		headPitch: Float
	) {
		val buffer = bufferSource.getBuffer(RenderType.eyes(emissive))

		this.parentModel.renderToBuffer(
			poseStack,
			buffer,
			15728640,
			OverlayTexture.NO_OVERLAY
		)
	}
}
