package ru.dbotthepony.mc.otm.entity

import net.minecraft.core.particles.ParticleTypes
import net.minecraft.sounds.SoundEvent
import net.minecraft.sounds.SoundEvents
import net.minecraft.world.entity.LivingEntity
import net.minecraft.world.entity.projectile.AbstractArrow
import net.minecraft.world.item.ItemStack
import net.minecraft.world.level.Level
import net.minecraft.world.phys.BlockHitResult
import net.minecraft.world.phys.EntityHitResult
import ru.dbotthepony.mc.otm.registry.game.MEntityTypes

class RocketProjectile(level: Level) : AbstractArrow(MEntityTypes.ROCKET, level) {
	var owner: LivingEntity? = null

	init {
		setBaseDamage(3.0)
		setCritArrow(false)
		pickup = Pickup.DISALLOWED
	}

	override fun tick() {
		if (!inGround) deltaMovement = deltaMovement.add(0.0, -0.05, 0.0)

		super.tick()
		if (level().isClientSide) {
			level().addParticle(ParticleTypes.CAMPFIRE_COSY_SMOKE, xOld, yOld, zOld, 0.0, 0.0, 0.0)
		}
	}

	override fun onHitEntity(result: EntityHitResult) {
		val hitEntity = result.entity

		if (!level().isClientSide && hitEntity != owner) {
			level().explode(owner, x, y, z, 2.0f, Level.ExplosionInteraction.NONE)
			discard()
		}
		if (hitEntity != owner) {
			super.onHitEntity(result)
		}
	}

	override fun onHitBlock(result: BlockHitResult) {
		if (!level().isClientSide) {
			level().explode(owner, x, y, z, 2.0f, Level.ExplosionInteraction.NONE)
			discard()
		}
		super.onHitBlock(result)
	}

	//asdasdadad
	override fun playSound(sound: SoundEvent, volume: Float, pitch: Float) {
		if (sound != SoundEvents.ARROW_HIT) {
			super.playSound(sound, volume, pitch)
		}
	}

	override fun getDefaultPickupItem(): ItemStack {
		return ItemStack.EMPTY
	}
}

